# 爱城市网app,PC网站扫码登录指南

''''''
'''1、app扫码授权'''
# 1、 打开认证界面(扫码界面)，第三方需要在PC网站拼接地址，打开扫码页面。可以使用ifream形式，并自定义样式
# 具体请求如下：
# url(GET)	https://new3.icity24.cn/platformcenter/scan-code-pc/index.html
# 参数
# 名字	        类型	是否必需	最大长度	描述	                                示例
# app_id	    String	是	        32	        爱城市网分配给第三方应用的AppId	        fea79d4c-9906-408c-86a5-8a092fda49b3
# redirect_uri	String	是	        -	        授权成功后回调页面，需转义，此url的域名必须和约定2中的一致	https://www.baidu.com?XXX=XXX
# scope	        String	是	        -	        接口权限值，多个以","分隔	            base_info,auth_user
# Result	    备注	用户授权成功后会跳转至开发者定义的回调页面，爱城市会在回调页面地址后面
# 拼接app_id,code,open_id,scope等参数。若用户取消授权，将关闭认证页面。

# 示例：https://auth.icity24.cn/icity/auth2.0/authorize?app_id=7f4ba7d2-0c44-4c65-866d-7f5e754360a3&redirect_uri=http%3A%2F%2Ftyzhaoshanggraph.industrychain.online&scope=base_info,auth_user

'''2、code -换取-> token'''
# 应用在拿到code之后应尽快去爱城市授权中心换取token， code过期时间为五分钟，过期将不可在用，且一个code只能使用一次。
# url(POST)	https://auth.icity24.cn/icity/auth2.0/token

# 名字	        类型	是否必需  最大长度	描述	                            示例
# app_id	    String	是	        32	    爱城市网分配给第三方应用的AppId	    fea79d4c-9906-408c-86a5-8a092fda49b3
# code	        String	是	        32	    授权成功后产生的code	            c417598b-5892-4217-81be-c3b6080e9fa1
# grant_type	String	是	        -	    authorization_code或者refresh_token，其中authorization_code代表使用code获取，refresh_token代表使用refresh_token	authorization_code
# refresh_token	String	是	        -	    当token过期时可用refresh_token刷新获取新token	c417598b-5892-4217-81be-c3b6080e9fa1
# sign	        String	是	        -	    签名，具体签名规则见附录	VJMIgEqAIe6928LVvKC8VFHHZhmW0WHVfjqTZpN8H5fhOlB+raGnMZGfRfPhv+LfJ236mq/lCSKIS14uS0cc7PvBFLlX0ks//aLdPySzsdsziWWPsPh9Jt2Wu/Z/yrCRjK1Ev4PVbXmOw2PDvWti2e0pO0mscgOiwPTHKgAaL84=

# 签名算法
import hashlib


def generate_sign(param):
    '''生成hash'''
    stringA = "&".join([f"{k}={param[k]}" for k in sorted(param)])
    # SHA256加密
    hash_sha256 = hashlib.sha256(stringA.encode('utf8')).hexdigest()
    return hash_sha256


params = {
    'appid': "fea79d4c-9906-408c-86a5-8a092fda49b3",  # 爱城市网appID
    'code': "c417598b-5892-4217-81be-c3b6080e9fa1",  # 授权成功后产生的code
    'grant_type': "authorization_code"
}
print(generate_sign(params))

# RSASSA-PKCS1-V1_5-SIGN使用私钥对hash签名
